#! /usr/bin/perl -wT

unless (@ARGV == 4) { die "Usage: $0 file offset interval length \n" }
($sourcefile, $offset, $interval, $length) = @ARGV;

unless (open SOURCE, "<", $sourcefile) {
  die "Couldn't open source file $sourcefile: $!; aborting";
}

my $buffer;
my $pos = $offset;
seek(SOURCE, $pos, 0);
my $filesize = -s $sourcefile;
my $written = 0;

if(open(NEW, ">extract")){
	while (read(SOURCE, $buffer, $length) && $written<$filesize && $written<250000000) { # 22 Nov 2017, safeguards to avoid filling disk in case of bad parameters
		print NEW $buffer;
		$pos += $interval;
        $written += $length;
        if (($pos<($filesize - $length)) && ($pos+$interval+$length)>$filesize) {
            $pos = $filesize - $length; # Move last chunk to go until end of file, 24 Oct 2013
        }
		seek(SOURCE, $pos, 0);
	}
	# close the new file on the server and we're done
close NEW;
}

close SOURCE;
